/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... ukazatel jako navratova hodnota funkce, 
                                        ukazatel a struktura
                                        ukazatelova aritmetika
*/

#include<iostream>
using namespace std;

// ukazatele a struktura:
struct Zlomek
{
	int citatel, jmenovatel;
};

// vypis zlomku pomoci reference:
void vypis1(const Zlomek &z)
{
	cout << z.citatel << " / " << z.jmenovatel << endl;
}

// vypis zlomku pomoci ukazatele:
void vypis(const Zlomek *uz)
{
	// cout << (*uz).citatel << " / " << (*uz).jmenovatel << endl;
	cout << uz->citatel << " / " << uz->jmenovatel << endl;
}

// ukazatele a pole:
void vypis(int *a, int n)
{
	for (int i = 0; i < n; i++)
	{
		cout << a[i] << ' ';
	}
	cout << endl;
}

// funkce vrati ukazatel na paty prvek pole a:
int *paty(int *a)
{
	return &a[4];
	/*
	int *p = &a[4];
	return p;
	*/
}

// funkce vrati referenci na paty prvek pole a:
int &paty1(int *a)
{
	return a[4];
	/*
	int &r = a[4];
	return r;
	*/
}

// CHYBA! ... funkce vraci adresu jiz neexistujici promenne
int *funkce1(int *a) 
{	
	int x = a[4];
	return &x;
}

// CHYBA! ... funkce vraci adresu jiz neexistujici promenne
int *funkce2()
{
	int x = 5;
	return &x;
}

// CHYBA! ... funkce vraci referenci na jiz neexistujici promennou
int &funkceR(int *a) 
{
	int x = a[4];
	return x;
}

void vypis(double *a, int n)
{
	for (int i = 0; i < n; i++)
	{
		cout << a[i] << ' ';
	}
	cout << endl;
}

double*  maximum(double *a, int n)
{
	int im = 0;
	for (int i = 0; i < n; i++)
		if (a[i] > a[im])
			im = i;
	return &a[im];
}

int main()
{
	// ukazatele a struktura:
	{
		Zlomek z = { 2,3 };
		vypis1(z);
		z.citatel = 8;
		Zlomek *uz;
		uz = &z;

		vypis1(*uz);
		vypis1(z);

		vypis(uz);
		vypis(&z);

		(*uz).citatel = -3;
		(*uz).jmenovatel = 5;
		vypis1(z);
		uz->citatel = 1;
		uz->jmenovatel = 7;
		vypis1(z);
	}

	/* Ukazatele a pole */
	{
		int a[10] = { 1,2,3,4,5,6,7,8,9,10 };
		int *ua = &a[0]; // ukazuje na prvni prvek
		int *va = &a[2]; // ukazuje na treti prvek
		int *wa = a;     // ukazuje na prvni prvek
		int x = 4;

		vypis(a, 10);
		vypis(ua, 10);
		vypis(wa, 10);
		vypis(va, 8);
		vypis(&x, 1);
		vypis(&x, 2); // vypise i pamet, "ktera mi nepatri";
	}

	/* Ukazatele a pole, ukazatelova aritmetika */
	{
		int a[10] = { 1,2,3,4,5,6,7,8,9,10 };
		int *ua = &a[0]; // ukazuje na prvni prvek
		int *va = &a[2]; // ukazuje na treti prvek

		// relacni operatory nad ukazateli:
		if (ua == a)
		{
			cout << "obsahuji stejnou adresu" << endl;
		}
		if (ua != a)
		{
			cout << "neobsahuji stejnou adresu" << endl;
		}
		if (ua < va)
		{
			cout << "ua ukazuje na prvek s mensim indexem" << endl;
		}

		// aritmeticke operatory nad ukazateli:
		ua = a;   // totez jako ua = &a[0]; 
		cout << (*ua) << endl;
		ua = ua + 1; // ukazuje na druhy prvek
		va = a + 9;  // totez jako va = &a[9]; 
		cout << (*ua) << endl;
		cout << (*va) << endl;

		int y = va - ua; // rozdil indexu v poli
		y = va - a;     // ziskam index prvku

		int x;
		x = *(a + 9); // x = a[9];
		cout << x << endl;

		// vypis prvku pole pomoci ukazatelove aritmetiky (nastrel)
		int *wa = a;     // ukazuje na prvni prvek
		int *xa = a + 9; // ukazuje na posledni prvek
		wa = a;
		cout << *wa << endl; // vypisu prvni prvek pole
		wa++;
		cout << *wa << endl;  // vypisu druhy prvek pole
		wa++;
		if (wa == a + 9)
			cout << "uz jsem na konci pole";
	}
	
	/* Ukazatel a reference jako navratova hodnota funkce */
	{
		int a[10] = { 1,2,3,4,5,6,7,8,9,10 };

		int *p = paty(a);
		cout << *p << endl;
		cout << p[1] << endl;
		cout << *paty(a) << endl;

		*p = 0;
		vypis(a, 10);
		*paty(a) = 100; // muze byt na leve strane prirazovaciho prikazu
		vypis(a, 10);


		int &x1 = paty1(a);
		x1 = -8;
		cout << x1 << endl;
		cout << paty1(a) << endl;
		vypis(a, 10);

		paty1(a) = 78; // muze byt na leve strane prirazovaciho prikazu
		vypis(a, 10);

        // priklady, co NEDELAT:
		cout << funkceR(a) << endl;
		funkceR(a) = 0; // prepisuji misto nekde v pameti
		vypis(a, 10);

		cout << *funkce1(a) << endl;
		*funkce1(a) = 66; // prepisuji misto nekde v pameti
		vypis(a, 10);

		cout << *funkce2() << endl;
		*funkce2() = 5; // prepisuji misto nekde v pameti
	}
	/* Priklady ... kostra */
	{
		double ax[10] = { 1,2,3,4,5,6,7,8,9,10 };
		vypis(ax, 10);
		cout << *maximum(ax, 10) << endl;
	}

	return 0;
}